'-----------------------------------------------------------------------------------------
' name                     : pga2310_m8515_6in_encoder.bas
' copyright                : (c) danzup
' purpose                  : PGA Preamp controller
' micro                    : AtMega8515
' version                  : 1.enc
' this version with 6 input, RC5 remote control & PGA2310 volume  ,
' mute ,backlight LED  control  , with Encoder : A-->PD2 ,B-->PD1 ,C -->GND
' modified time delay for volume set , stop at +3dB for PGA2310
'
'Modified by FarmTech 20.09.2010  EDIT INPUT SELECT TEXT via RC5

' Edit the Text for you input How do it work :
'
' Select Edit input text via menu button

' Upper Line Show The Current Text
' Bottom Line Is Where You Write The New Text

'
' RC5 COMMANDS FOR EDIT TEXT :

' STEP 1 : VOL - : SELECT THE TEXT TO EDIT  steps  from 1 to 6 in the input select text
' STEP 2 : CH +  : scroll letters up
' STEP 3 : CH -  : scroll letters down
' STEP 4 : VOL + : SELECT the letter , it goes next letter do step 2 to 4
'                  until you have the text you like to use

' STEP 5 : MUTE  : save the text to memery and show it on lcd
'                  use VOL- to select next or press power on/off to exit

' STEP 6 : Power on/off  EXIT Edit mode
' ATT ATT :IF YOU LIKE TO EXIT AND NOT SAVE JUST PRESS POWER ON/OFF -

' 22.09.2010 LERAN a new RC5 Remote controller

' New in menu is add a new remote

' This ONLY work with a RC5 remote

' When you you enter this menu you will be ask to :

' PUSH A BUTTON  = this will check if your remote is a RC5( use 1 of the buttons CH+, CH-, VOL+, VOL- or Mute )
' If NOT then it cant be used PUSH menu to exit this setup

' If it is a RC5 you can now add this to controlle your hardware

' Just 5 steps to setup buttons Power, CH+, CH-, VOL+, VOL- & Mute

' Thats it simple and easy  enjoy


' UPDATE
'added 2 encoders
'1 button for MUTE / ON_OFF
'moved RC5 to PORTC.7


'-----------------------------------------------------------------------------------------
'$sim
$regfile = "M8515.dat"                                      ' specify the used micro m32def
$crystal = 8000000                                          ' used crystal frequency
$hwstack = 32
$swstack = 30
$framesize = 34
Ddrd = &B11000000                                           ' PD6...PD7 are output, PD0...PD5 are input
Portd = &B00111111                                          ' PD0...PD5 pull-up resistor enable
Ddra = &B11111111                                           ' PA0...PA7 are output ,input relay control
Ddrb = &B11111111                                           ' PB0...PB7 are output
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 20 * 2
Cursor Off
Cls
' my lcd setup
'Config Lcdpin = Pin , Db4 = Portc.5 , Db5 = Portc.4 , Db6 = Portc.3 , Db7 = Portc.2 , E = Portc.6 , Rs = Portc.7
'Config Lcd = 24 * 2

Config Spi = Soft , Din = Portb.4 , Dout = Portb.0 , Ss = Portb.1 , Clock = Portb.3
Config Porta = Output
Config Portb.2 = Output                                     'mute line for PGA2310

Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim Count As Byte                                           'On/Off button  PortD.0
Dim A As Bit , B As Bit                                     'Menu button  PortD.4
Dim W As Word
Dim G As Byte
Dim Inp_sel As Byte
Dim Pwr As Bit
'Dim Mut As Bit
'Dim Vol_out As Byte
'Dim L As Byte
'Dim R As Byte
'L = 70
'R = 70
Dim Vol_u As Byte , Vol_d As Byte                           ', Lcd_vol_l As Byte , Lcd_vol_r As Byte       'new commnds var vol+ , vol-
Dim Shift_l As Byte , Shift_r As Byte , Power_1 As Byte     'new commnds var ch+ , ch- , power on/off
Dim My_address As Byte , Mut_a As Byte                      'new commnds var  new address , mute
Dim Ok As Byte
Const Por = "PUSH POWER      "
Const Chu = "PUSH CH +       "
Const Chd = "PUSH CH -       "
Const Volu = "PUSH VOL +      "
Const Vold = "PUSH VOL -      "
Const Mutonoff = "PUSH MUTE       "
Declare Sub Get_remote                                      'sub get NEW RC COMMANDS
Dim Menu_text(4) As Eram String * 16 At &H80                'only used 6 for ths test
Dim X As String * 16                                        'the new menu_text string
Dim Menu_index As Byte
Dim First_time As Byte , Save_yn As Byte
Declare Sub Rc5_new
Declare Sub Input_sel
Declare Sub Input_edit
Declare Sub Edit_input_txt
Reset Portb.2                                               'mute PGA2310
'Declare Sub Spio                                            '
Declare Sub Shiftlf                                         '
Declare Sub Shiftrt                                         '
'Declare Sub Volup                                           '
'Declare Sub Voldn                                           '
Declare Sub Poweron                                         '
Declare Sub Poweroff                                        '
Declare Sub Af_sel                                          '
Declare Sub Pwr_onof                                        '
'Declare Sub Mute                                            '
'Declare Sub Balance_r                                       '
'Declare Sub Balance_l                                       '
Declare Sub Menu                                            '
Declare Sub Bklght                                          '

' check if eeprom is emty if so add the input select text as standart
Readeeprom First_time , 128
If First_time <> 255 Then
   nop
Else
   Menu_text(1) = "TAPE    Selected"
   Menu_text(2) = "TUNE    Selected"
   Menu_text(3) = "CD      Selected"
   Menu_text(4) = "PC      Selected"
  ' Menu_text(5) = "DVD     Selected"
  ' Menu_text(6) = "AUX     Selected"
End If

Readeeprom Ok , 60
If Ok <> 22 Then
 My_address = 08
 Power_1 = 12
 Shift_r = 33
 Shift_l = 32
 Vol_u = 17
 Vol_d = 16
 Mut_a = 13
Else
  Readeeprom My_address , 62
  Waitms 25
  Readeeprom Power_1 , 64
  Waitms 25
  Readeeprom Shift_r , 66
  Waitms 25
  Readeeprom Shift_l , 68
  Waitms 25
  Readeeprom Vol_u , 70
  Waitms 25
  Readeeprom Vol_d , 72
  Waitms 25
  Readeeprom Mut_a , 74
End If
Cls
'check for Edit mode - or add a new remote command for edit , my remote only have 5 buttons
Config Rc5 = Pinc.7 , Wait = 2000                           'pin where is conected ir senzor
'encoder 1 volume
Enc_a Alias Pind.1
Set Enc_a
On Int0 Int_0
Enable Int0
Config Int0 = Falling

'encoder 2 select input
Enc_b Alias Pind.5
Set Enc_b
On Int1 Int_1
Enable Int1
Config Int1 = Falling



Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Start Timer1
Set Portd.7                                                 'backlight on
Reset Portb.2                                               'mute PGA2310
'Spiinit                                                     'init the spi bus for PGA2310 talk with
'Call Spio
Pwr = 0                                                     '0 =stand-by ; 1 = power on
'Mut = 1                                                     ' 0 =mute , 1 = normal
Inp_sel = &B00000001                                        'default selected first input
Cls                                                         'clear the LCD display
Porta = Inp_sel                                             ' will set the input  selected default
Lcd "Preamp controler"                                      'display this at the top line
Lowerline                                                   'select the lower line
Lcd "v=?.enc(c)danzup"                                      'display this at the lower line
Wait 1

Cls
Enable Interrupts
'--------------------------------------------------------------------------
If Pwr = 0 Then
Call Poweroff
End If
'--------------------------------------------------------------------------
Do

If Pwr = 1 Then
 If W => 33800 Then
  Reset Portd.7                                             'will set the Port D bit 7 to 0V backlight off
'(  If G > 0 And G < 3 Then
    Call Af_sel
    Home Lowerline
    Lcd "Volume " ; Lcd_vol_l ; "       "
    G = 3
 End If
')
 End If
Getrc5(address , Command)                                   'read if we have remote ir command
  If Address = My_address Then
     Command = Command And &B01111111
  End If
Select Case Command
'---- this codes are for my remote , change code to your suit ! ----------------
   Case Shift_l : Call Shiftlf                              'remote command code for CH up
   Case Shift_r : Call Shiftrt                              'remote command code for CH down
   'Case Vol_u : Call Volup                                  'remote command code for Vol +
   'Case Vol_d : Call Voldn                                  'remote command code for Vol -
  ' Case Mut_a : Call Mute                                   'remote command code for Mute
   Case Power_1 : Call Pwr_onof                             'remote command code for On/Off
End Select
A = Pind.0
B = Pind.4                                                  'Menu button

If Pind.0 = 0 Then                                          'Menu - On/Off button
   'mute / on off
   Count = 0                                                'reset counter for select mute/on_off
   Do
    Incr Count
    Waitms 100
   Loop Until Pind.0 = 1 Or Count > 20                      'exit if pin go high or 2 sec

   If Count < 15 Then                                       ' < 1500 msec
      'Call Mute
   Else                                                     '> 1500 msec
      Call Pwr_onof
   End If
   Waitms 200
   End If

   If B = 0 Then
      Waitms 2
      Call Menu                                             'button Menu presed
   End If
End If

If Pwr = 0 Then
A = Pind.0                                                  'On/Off button
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = My_address Then
     Command = Command And &B01111111
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case Power_1 : Call Pwr_onof                             'remote command code for On/Off
 End Select
 If A = 0 Then                                              'now we read the push buttons for command
      Waitms 2
      Call Pwr_onof                                         'button On/Off presed
 End If
End If

Loop

End


'-----------Pwr_onof-----------------
Sub Pwr_onof:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------Poweron------------------------
Sub Poweron:
Set Portb.2                                                 'unmute  PGA2310
Set Portd.6                                                 'power relay on
Call Bklght
Display On                                                  'turn display on
Cls
Lcd " Power On !    "
Waitms 500
Cls
Porta = Inp_sel
Call Af_sel
'   Lcd_vol_l = L / 4
'   Lcd_vol_r = R / 4
'Home Lowerline
'Lcd "Volume " ; Lcd_vol_l ; "       "
Waitms 100
Enable Int0
Enable Int1
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Reset Portb.2                                               'mute PGA2310
Reset Portd.6                                               'power relay off
Reset Portd.7                                               'backlight off
Display Off                                                 'turn display off
Porta = &B00000000                                          ' mute
Waitms 500
Disable Int0
Disable Int1
End Sub
'---------shift input Left----------
Sub Shiftlf:
Call Bklght
If Inp_sel >= 1 And Inp_sel < 32 Then
Rotate Inp_sel , Left
End If
Porta = Inp_sel
Call Af_sel
Waitms 200
End Sub
'--------shift input right----------
Sub Shiftrt:
Call Bklght
If Inp_sel >= 2 And Inp_sel < 33 Then
Rotate Inp_sel , Right
End If
Porta = Inp_sel
Call Af_sel
Waitms 200
End Sub
'(
'-------bring volume up-----------
Sub Volup:
Call Bklght
   If L = 254 Then
        L = 252
   End If
   If R = 254 Then
        R = 252
   End If
        L = L + 2
        R = R + 2
   Lcd_vol_l = L / 4
   Lcd_vol_r = R / 4
   Home Lowerline
   Lcd "Volume " ; Lcd_vol_l ; "       "
   Call Spio
   Waitms 5
End Sub

'--------bring volume down----------
Sub Voldn:
Call Bklght
   If L = 0 Then
        L = 2
   End If
   If R = 0 Then
        R = 2
   End If
        L = L - 2
        R = R - 2
   Lcd_vol_l = L / 4
   Lcd_vol_r = R / 4
   Home Lowerline
   Lcd "Volume " ; Lcd_vol_l ; "       "
   Call Spio
   Waitms 5
End Sub
')
'------Af_sel---------------------------

Sub Af_sel:
Home Upper
If Inp_sel = 1 Then
X = Menu_text(1)
Lcd X
End If
If Inp_sel = 2 Then
X = Menu_text(2)
Lcd X
End If
If Inp_sel = 4 Then
X = Menu_text(3)
Lcd X
End If
If Inp_sel = 8 Then
X = Menu_text(4)
Lcd X
End If
'(
If Inp_sel = 16 Then
X = Menu_text(5)
Lcd X
End If
If Inp_sel = 32 Then
X = Menu_text(6)
Lcd X
End If
')
End Sub
'(
'------- Mute ----------
Sub Mute:
Call Bklght
   Mut = Not Mut
   If Mut = 1 Then
      Set Portb.2
      Porta = Inp_sel
      Home Lowerline
      Lcd "Volume " ; Lcd_vol_l ; "  "
      Wait 1
   Else
      Porta = &B00000000
      Reset Portb.2
      Home Lowerline
      Lcd "MUTE      !!!  "
      Wait 1
   End If
End Sub
'-----Send data to PGA2310------
Sub Spio:
   Spiinit
   Spiout L , 1
   Spiout R , 1
End Sub
')
'-----------Menu-----------------
Sub Menu:
G = G + 1
Call Bklght                                                 'backlight on
If G > 1 Then
   G = 0
End If
If G = 2 Then
Cls
   Home Lower
   Lcd " Adjust Volume  "
   Waitms 200
End If

If G = 0 Then
Cls
   Home Upper
   Lcd " Edit Input Text"
   Waitms 200
End If

If G = 1 Then
Cls
   Home Upper
   Lcd "SETUP REMOTE RC5"
   Waitms 200
End If

End Sub
'------- Bklght------------------
Sub Bklght:
 Set Portb.6                                                'backlight on
 W = 0
 Timer1 = W                                                 'reset timer 1
End Sub
'---Nu le folosesc deocamdata--------------
'(
'--------------Balance left-----------------
Sub Balance_r:
   If L = 254 Then
          L = 252
   End If
   If L = 0 Then
          L = 2
   End If
   If R = 0 Then
          R = 2
   End If
   If R = 254 Then
          R = 252
   End If
   If L < R Then
          L = L + 2
            Else
          R = R - 2
   End If
   Call Spio
   Lcd_vol_l = L / 4
   Lcd_vol_r = R / 4
End Sub
'------------Balance  right----------
Sub Balance_l
   If R = 0 Then
      R = 2
   End If
   If R = 254 Then
      R = 252
   End If
   If L = 0 Then
      L = 2
   End If
   If L = 254 Then
      L = 252
   End If
   If R < L Then
      R = R + 2
   Else
      L = L - 2
   End If
   Call Spio
   Lcd_vol_l = L / 4
   Lcd_vol_r = R / 4
End Sub
')
'-----------EDIT INPUT TEXT-------------------
Sub Edit_input_txt:
Disable Int0
Enable Interrupts
Set Portb.6
Stop Timer1
Command = 255
Address = 255
Local My_chr As Byte
Local X_chr As Byte
Local Menu_point As Byte
Local My_string As String * 16
My_chr = 65                                                 'start at A
X_chr = 1                                                   'first chr
Menu_point = 1                                              'first index in input select
My_string = ""
Locate 1 , 1                                                'read the current text of input index
X = Menu_text(menu_point)
Lcd X
                                                   'Blink
Locate 2 , 1
Lcd Chr(my_chr)
Shiftcursor Left
Do

Getrc5(address , Command)                                   'read if we have remote ir command
  If Address = My_address Then
     Command = Command And &B01111111
  End If

 Select Case Command
   'remote command code for CH up  letter +
   Case Shift_l : Incr My_chr
              If My_chr = 33 Then My_chr = 48
              If My_chr > 90 Then My_chr = 32
              If My_chr = 58 Then My_chr = 65
              Locate 2 , X_chr
              Lcd Chr(my_chr)
              Waitms 220
              Shiftcursor Left

   'remote command code for CH down letter -
   Case Shift_r : Decr My_chr
              If My_chr = 47 Then My_chr = 32
              If My_chr < 32 Then My_chr = 90
              If My_chr = 65 Then My_chr = 57
              Locate 2 , X_chr
              Lcd Chr(my_chr)
              Waitms 220
              Shiftcursor Left

   'remote command code for Vol +  select letter and goto next
   Case Vol_u : My_string = My_string + Chr(my_chr)         ' add the chr to the string jump to next 1 to 16
            Incr X_chr
            My_chr = 65                                     '97
            Locate 2 , X_chr
            Lcd Chr(my_chr)
            Shiftcursor Left
            Waitms 220

            If X_chr = 17 Then                              'check that len of text is < max len (16)
               Menu_text(menu_point) = My_string
               Exit Do
            End If

    'remote command code for Vol -  select the input text to edit
   Case Vol_d : Incr Menu_point
            If Menu_point > 6 Then Menu_point = 1
            Cls
            Locate 1 , 1
            X = Menu_text(menu_point)
            Locate 1 , 1
            Lcd X
            My_string = ""
            X_chr = 1
            My_chr = 65
            Locate 2 , 1
            Lcd Chr(my_chr)
            Shiftcursor Left
            Waitms 220
   ' remote command code for power on/off    EXIT NO SAVE leave  it as it was
   Case Power_1 : Command = 255
             Address = 255
             Exit Do

   'remote command code for Mute   SAVE it and reset
   Case Mut_a : If My_string = "" Then                      'nothing in the string
                  Command = 255
                  Address = 255
                  Exit Do
              Else
                  While Len(my_string) < 16
                     My_string = My_string + " "            'add space
                  Wend
                  Menu_text(menu_point) = My_string         'save the new text and show it
                  Waitms 25
                  Cls
                  Locate 1 , 1
                  X = Menu_text(menu_point)
                  Waitms 25
                  Lcd X                                     'show the new text for input
                  My_chr = 65
                  X_chr = 1
                  My_string = ""
                  Locate 2 , X_chr
                  Lcd Chr(my_chr)
                  Shiftcursor Left
                  ' use VOL- to select other edit or press Power on/off to exit
             End If

    End Select
 Command = 255
 Address = 255

Loop

Cls
Lcd "EXIT ...."
Wait 2
My_string = ""
G = 4
Start Timer1                                                'select volume
Call Af_sel                                                 'show selectet input
End Sub

'------Input_sel edit mode ----------------------
Sub Input_edit:
Locate 1 , 1
   X = Menu_text(menu_index)
   Waitms 25
   Lcd X
End Sub

' setup new RC5 remote
Sub Rc5_new:
Disable Int0
Enable Interrupts
Set Portb.6
Stop Timer1
   Locate 1 , 1
   Lcd "NEW REMOTE RC5  "
   Locate 2 , 1
   Lcd "SETUP REMOTE NOW"
   Wait 3
   Cls
   Lcd "STEP 1 OF 6     "
   Wait 1
   Locate 2 , 1
   Lcd "PUSH A BUTTON   "

   Do
      Getrc5(address , Command)
      If Address <> 255 Then
         If Command <> 255 Then
            Command = Command And &B01111111
         End If
      End If
      If Pind.4 = 0 Then
         Waitms 500
         Goto Oh_on
      End If
   Loop Until Address <> 255
   My_address = Address
   Locate 1 , 1
   Lcd "OK FOUND REMOTE "
   Locate 2 , 1
   Lcd "PROGRAM BUTTONS "
   Wait 1
   Cls

   Locate 1 , 1
   Lcd Por
   Call Get_remote
   Power_1 = Command
   Wait 1
   Cls
   Locate 1 , 1
   Lcd Chu
   Call Get_remote
   Shift_l = Command
   Wait 1
   Cls
   Locate 1 , 1
   Lcd Chd
   Call Get_remote
   Shift_r = Command
   Wait 1
   Cls
   Locate 1 , 1
   Lcd Volu
   Call Get_remote
   Vol_u = Command
   Wait 1
   Cls
   Locate 1 , 1
   Lcd Vold
   Call Get_remote
   Vol_d = Command
   Wait 1
   Cls
   Locate 1 , 1
   Lcd Mutonoff
   Call Get_remote
   Mut_a = Command
    Wait 1
   Cls

  Locate 1 , 1
 Lcd "SAVE DATA   "
  Locate 2 , 1
  Ok = 22
  Writeeeprom Ok , 60
  Writeeeprom My_address , 62
  Waitms 25
  Writeeeprom Power_1 , 64
  Waitms 25
  Writeeeprom Shift_r , 66
  Waitms 25
  Writeeeprom Shift_l , 68
  Waitms 25
  Writeeeprom Vol_u , 70
  Waitms 25
  Writeeeprom Vol_d , 72
  Waitms 25
  Writeeeprom Mut_a , 74

 Waitms 25
 Lcd "READY TO USE"

Oh_on:
 Wait 1

 Cls
 G = 4
Start Timer1                                                'select volume
Call Af_sel                                                 'show selectet input

End Sub

Sub Get_remote()

 Do
   Getrc5(address , Command)
   If Address = My_address Then
      If Command <> 255 Then
         Command = Command And &B01111111
      End If
   End If
 Loop Until Address <> 255

 Locate 2 , 1
 Lcd "OK > "

End Sub

'-------------------Int_0------------------------
Int_0:
Disable Int0
  If Enc_a = 0 Then
    If G = 2 Then
     ' Call Volup
    End If
    If G = 0 Then
       Call Edit_input_txt
    End If
    If G = 1 Then
       Call Rc5_new
    End If
  Else
    If G = 2 Then
      'Call Voldn
    End If
    If G = 0 Then
       Call Edit_input_txt
    End If

    If G = 1 Then
       Call Rc5_new
    End If

  End If
Set Gifr.6                                                  'asta e cea mai mare smecherie !
Enable Int0
Return


'  - Encoder pin - Int1(A) & Pind.5(B) commen to gnd -----
Int_1:
Disable Int1
If Enc_b = 0 Then
   Call Shiftlf()
Else
   Call Shiftrt()
End If
Set Gifr.7
Enable Int1
Return